var search_data = {"index":{"searchIndex":["gen","code","if","method","predicate","monitormethod","nilpasser","wrapmethod","[]()","bind_const()","bind_proc()","bound_eval()","call()","class_method_exists?()","class_monitors()","class_wrap()","class_wrap!()","classes_monitors()","clone()","def_block_gen()","def_self()","generate_binding()","initialize_class()","initialize_instance()","instance_method_exists?()","instance_monitors()","instance_wrap()","instance_wrap!()","instances_monitors()","local_var()","make_test()","make_test()","make_test_code()","method_monitor()","new()","new()","new()","new_local_var()","oldify_name()","raw_class_wrap()","raw_instance_wrap()","raw_singleton_wrap()","setup()","singleton_method_exists?()","singleton_monitors()","singleton_wrap()","singleton_wrap!()","teardown()","teardown()","test()","to_old()","unbound_method_monitor()"],"longSearchIndex":["gen","gen::code","gen::if","gen::method","gen::predicate","monitormethod","nilpasser","wrapmethod","gen::if::[]()","gen::code#bind_const()","gen::code#bind_proc()","gen::code#bound_eval()","nilpasser#call()","wrapmethod::class_method_exists?()","monitormethod::class_monitors()","wrapmethod::class_wrap()","wrapmethod::class_wrap!()","monitormethod::classes_monitors()","nilpasser::clone()","gen::method::def_block_gen()","gen::method::def_self()","gen::code#generate_binding()","nilpasser#initialize_class()","nilpasser#initialize_instance()","wrapmethod::instance_method_exists?()","monitormethod::instance_monitors()","wrapmethod::instance_wrap()","wrapmethod::instance_wrap!()","monitormethod::instances_monitors()","gen::code#local_var()","gen::predicate#make_test()","gen::predicate::make_test()","gen::predicate#make_test_code()","monitormethod::method_monitor()","gen::code::new()","monitormethod::new()","nilpasser::new()","gen::code#new_local_var()","wrapmethod::oldify_name()","wrapmethod::raw_class_wrap()","wrapmethod::raw_instance_wrap()","wrapmethod::raw_singleton_wrap()","nilpasser#setup()","wrapmethod::singleton_method_exists?()","monitormethod::singleton_monitors()","wrapmethod::singleton_wrap()","wrapmethod::singleton_wrap!()","nilpasser::teardown()","nilpasser#teardown()","nilpasser::test()","nilpasser#to_old()","monitormethod::unbound_method_monitor()"],"info":[["Gen","","Gen.html","","<p>This module provides code and method generation tools\n<p>This class is just sugar on Gen::Predicate\n"],["Gen::Code","","Gen/Code.html","",""],["Gen::If","","Gen/If.html","",""],["Gen::Method","","Gen/Method.html","",""],["Gen::Predicate","","Gen/Predicate.html","",""],["MonitorMethod","","MonitorMethod.html","","<p>Example usage:\n\n<pre>instance_monitor Array, :map do |map|\n  method_monitor nil, If[empty: true], If[args: 1] ...</pre>\n"],["NilPasser","","NilPasser.html","",""],["WrapMethod","","WrapMethod.html","",""],["[]","Gen::If","Gen/If.html#method-c-5B-5D","(*test_hashes)",""],["bind_const","Gen::Code","Gen/Code.html#method-i-bind_const","(a_const)","<p>Bound within `#bound_eval` as `const_#{position in @bound_constants}`\n"],["bind_proc","Gen::Code","Gen/Code.html#method-i-bind_proc","(a_proc)","<p>Bound within `#bound_eval` as `proc_#{position in @bound_procs}`\n"],["bound_eval","Gen::Code","Gen/Code.html#method-i-bound_eval","(source)","<p>Evaluate a string using the locally bound procs and constants\n"],["call","NilPasser","NilPasser.html#method-i-call","(*args, &block)",""],["class_method_exists?","WrapMethod","WrapMethod.html#method-c-class_method_exists-3F","(klass, method_name)",""],["class_monitors","MonitorMethod","MonitorMethod.html#method-c-class_monitors","(klass, method_predicate=nil, &block)",""],["class_wrap","WrapMethod","WrapMethod.html#method-c-class_wrap","(klass, method_name, &block)",""],["class_wrap!","WrapMethod","WrapMethod.html#method-c-class_wrap-21","(klass, method_name, &block)",""],["classes_monitors","MonitorMethod","MonitorMethod.html#method-c-classes_monitors","(klass_predicate=nil, method_predicate=nil, &block)",""],["clone","NilPasser","NilPasser.html#method-c-clone","(klass, method_name)",""],["def_block_gen","Gen::Method","Gen/Method.html#method-c-def_block_gen","(name, initializer=name.to_s, default_args=nil)","<p>define a block generator on both the class and the instance\n"],["def_self","Gen::Method","Gen/Method.html#method-c-def_self","(method_name, &block)","<p>define a method on both the class and the instance\n"],["generate_binding","Gen::Code","Gen/Code.html#method-i-generate_binding","(a_binding=binding)","<p>Generate a binding containing the locally bound procs and constants\n"],["initialize_class","NilPasser","NilPasser.html#method-i-initialize_class","(klass, method_name=nil, accepts_args=true)",""],["initialize_instance","NilPasser","NilPasser.html#method-i-initialize_instance","(inst, method_name=nil, accepts_args=true)",""],["instance_method_exists?","WrapMethod","WrapMethod.html#method-c-instance_method_exists-3F","(klass, method_name)",""],["instance_monitors","MonitorMethod","MonitorMethod.html#method-c-instance_monitors","(klass, method_predicate=nil, &block)",""],["instance_wrap","WrapMethod","WrapMethod.html#method-c-instance_wrap","(klass, method_name, rewrap=false, &block)","<p>See `WrapMethod::raw_instance_wrap`. This adds a check that the method exists and returns `nil` if it …\n"],["instance_wrap!","WrapMethod","WrapMethod.html#method-c-instance_wrap-21","(klass, method_name, rewrap=false, &block)","<p>See `WrapMethod::raw_instance_wrap`. This adds a check that the method exists and raises an `ArgumentError` …\n"],["instances_monitors","MonitorMethod","MonitorMethod.html#method-c-instances_monitors","(klass_predicate=nil, method_predicate=nil, &block)",""],["local_var","Gen::Code","Gen/Code.html#method-i-local_var","()","<p>The current local variable, of form: `“x_#{@local_var_count}”`\n"],["make_test","Gen::Predicate","Gen/Predicate.html#method-i-make_test","(klass, test_name, test_hash)","<p>given a class, a name for the test (instance) method, and a test hash, generate a predicate\n"],["make_test","Gen::Predicate","Gen/Predicate.html#method-c-make_test","(klass, test_name, test_hash)","<p>An alias of `#make_test`\n"],["make_test_code","Gen::Predicate","Gen/Predicate.html#method-i-make_test_code","(test_hash)","<p>you enter a nested hash where the branches define the execution path and the leaves either have a value …\n"],["method_monitor","MonitorMethod","MonitorMethod.html#method-c-method_monitor","(args_predicate=nil, block_predicate=nil, &passed_block)","<p>return a proc that takes a method block takes |*args, &amp;block| and returns [new_args, new_block] or …\n"],["new","Gen::Code","Gen/Code.html#method-c-new","(local_var_count=0, bound_procs=[], bound_constants=[])",""],["new","MonitorMethod","MonitorMethod.html#method-c-new","()",""],["new","NilPasser","NilPasser.html#method-c-new","(obj, method_name=nil, accepts_args=true)",""],["new_local_var","Gen::Code","Gen/Code.html#method-i-new_local_var","(other)","<p>Assigns a new local variable to its argument (incrementing `@local_var_count`)\n"],["oldify_name","WrapMethod","WrapMethod.html#method-c-oldify_name","(method_name)",""],["raw_class_wrap","WrapMethod","WrapMethod.html#method-c-raw_class_wrap","(klass, method_name, rewrap=false, &block)","<p>The block is passed the previous method (frozen). `rewrap=true` means the method will be redefined (safely) …\n"],["raw_instance_wrap","WrapMethod","WrapMethod.html#method-c-raw_instance_wrap","(klass, method_name, rewrap=false, &block)","<p>The block is passed the previous unbound method (frozen). `rewrap=true` means the method will be redefined …\n"],["raw_singleton_wrap","WrapMethod","WrapMethod.html#method-c-raw_singleton_wrap","(object, method_name, rewrap=false, &block)","<p>The block is passed the previous method (frozen). `rewrap=true` means the method will be redefined (safely) …\n"],["setup","NilPasser","NilPasser.html#method-i-setup","()",""],["singleton_method_exists?","WrapMethod","WrapMethod.html#method-c-singleton_method_exists-3F","(klass, method_name)",""],["singleton_monitors","MonitorMethod","MonitorMethod.html#method-c-singleton_monitors","(object, method_predicate=nil, &block)",""],["singleton_wrap","WrapMethod","WrapMethod.html#method-c-singleton_wrap","(object, method_name, rewrap=false, &block)","<p>See `WrapMethod::raw_singleton_wrap`. This adds a check that the method exists and returns `nil` if it …\n"],["singleton_wrap!","WrapMethod","WrapMethod.html#method-c-singleton_wrap-21","(object, method_name, rewrap=false, &block)","<p>See `WrapMethod::raw_singleton_wrap`. This adds a check that the method exists and raises an `ArgumentError` …\n"],["teardown","NilPasser","NilPasser.html#method-c-teardown","(nil_passers)",""],["teardown","NilPasser","NilPasser.html#method-i-teardown","()",""],["test","NilPasser","NilPasser.html#method-c-test","(a_caller, block)",""],["to_old","NilPasser","NilPasser.html#method-i-to_old","(x)","<p>stuff -&gt; @@old_stuff\n"],["unbound_method_monitor","MonitorMethod","MonitorMethod.html#method-c-unbound_method_monitor","(bound_predicate=nil, args_predicate=nil, block_predicate=nil, &passed_block)","<p>return a proc that takes an unbound method block takes |bound_to, *args, &amp;block| and returns [new_args, …\n"]]}}